library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_signed.all;

entity tb_compito is
end tb_compito;

architecture tbbcompito1 of tb_compito is

component operazioni is
	port(din: in std_logic_vector(15 downto 0);
	clk, start: in std_logic;
	ris: out std_logic_vector(15 downto 0);
	fine: out std_logic);
end component;

signal din,ris:std_logic_vector(15 downto 0);
signal clk,start,fine: std_logic;

begin
	dut: operazioni port map (din,clk,start,ris,fine);
	
	process
     begin
	  clk <= '0';
	  wait for 5 ns;
	  clk <= '1';
	  wait for 5 ns;
    end process;
	
	process
	begin
		start <= '0';
		wait for 1 ns;
		start <= '1';
		wait for 10 ns;
		start <= '0';
		wait for 69 ns;
	end process;
	
	din <= "0000000000000000" after 11 ns,  -- op not
	       "1100100110010000" after 21 ns,	-- d0
		   
		   "0000000000000001" after 91 ns,  -- op or
	       "0000000010010000" after 101 ns,	-- d0
		   "0000000000000011" after 111 ns,	-- d1
		   
		   "0000000000000010" after 171 ns, -- op add
	       "0000000000001100" after 181 ns,	-- d0
		   "0000000000000011" after 191 ns,	-- d1
		   
		   "0000000000000011" after 251 ns, -- op mac
	       "0000000000000010" after 261 ns,	-- d0
		   "0000001100000010" after 271 ns;	-- d1 
		   
end tbbcompito1;

